/////////////////////////////////////////////////////////////////////////////////////////
//                                                                                     //
// Kitchen Timer gadget  Richard Williams 2010                                        //
//                                                                                     //
// Alarm clock sound courtesy of                                                       //
// http://www.pacdv.com/sounds/domestic_sounds.html                                    //
//                                                                                     //
// Alarm clock image courtesy of                                                       //
// http://www.visualpharm.com/                                                         //
///////////////////////////////////////////////////////////////////////////////////////// 
var t;
var t1;
var hrs;
var mins;
var secs;
var limit;
var startCount;
var increment = 1000;
var volSetting;
var alarmRepeat;
var alarmFile;
function showTime(milliSecs){
	// convert milliseconds to string
	secs = parseInt(milliSecs/1000);
	mins = parseInt(secs/60);
	secs = addZero(secs%60);
	hrs = addZero(parseInt(mins/60));
	mins = addZero(mins%60);
	var string = hrs+":"+mins+":"+secs;
	return (string);
}
function addZero(f){
    if(f<10)f = "0"+f;
	return (f);
}
function mainDone(){
	// come here when the main timer fires
	stopTimer();
	setButton("alarm","images/alarm-clock-icon.png",function(){stopSound();});
	soundAlarm();
	return;
}
function counting(){
	// come here when the secondary timer fires and show the timer counting down.
    limit = limit-increment;
	if(limit<0){
		document.getElementById("counter").innerHTML = showTime(limit)+" stalled"; // should never happen!
		return;
	}
	document.getElementById("counter").innerHTML = showTime(limit);
    t = setTimeout("counting()",increment);
	return;
}
function soundAlarm(){
	// give the bgsound tag some settings
    document.getElementById("clock").loop = alarmRepeat;
	document.getElementById("clock").volume = volSetting;
	document.getElementById("clock").src = alarmFile;
}
function showImage(img){
	document.getElementById("alarm").src = img;
}
function init(){
    System.Gadget.settingsUI = "settings.html";
	System.Gadget.onSettingsClosed = settingsClosed;
	System.Gadget.Flyout.file = "flyout.html";
	setButton("alarm","images/blank.png",function(){doNothing();});
	alarmFile = System.Gadget.Settings.readString("soundURL");
	if(alarmFile == "")alarmFile = "./sounds/alarm-clock-1.wav";
	alarmRepeat = System.Gadget.Settings.readString("soundRepeat");
	if(alarmRepeat == "")alarmRepeat = 1;
	if(System.Gadget.Settings.readString("volume") == "on" || System.Gadget.Settings.readString("volume") == "")volSetting = 0;else volSetting = -10000;
	if(document.getElementById("counter").innerHTML != "00:00:00"){
	    setButton("start","./images/go.png",function(){startTimer();});
		setButton("pause","./images/pause_dim.png",function(){doNothing();});
		setButton("stop","./images/stop_dim.png",function(){doNothing();});
	}else{
	    setButton("start","./images/go_dim.png",function(){doNothing();});
		setButton("pause","./images/pause_dim.png",function(){doNothing();});
		setButton("stop","./images/stop_dim.png",function(){doNothing();});
	}
}
function startTimer(){
	// get things going.  the main timeout (t1) is for the exact milliseconds set by the user.  the secondary timeout (t) changes the visible timer.
    startCount = document.getElementById("counter").innerHTML;
    hrs = parseInt(startCount.substring(0,2));
    mins = parseInt(startCount.substring(3,5));
    secs = parseInt(startCount.substring(6));
    limit = (hrs*60*60+mins*60+secs)*1000;
    t = setTimeout("counting()",increment);
    t1 = setTimeout("mainDone()",limit);
	setButton("start","./images/go_dim.png",function(){doNothing();});
	setButton("pause","./images/pause.png",function(){pauseTimer();});
	setButton("stop","./images/stop.png",function(){stopTimer();});
}
function pauseTimer(){
	// wait for the play button to be pressed again
    clearTimeout(t);
	clearTimeout(t1);
	init();
}
function stopTimer(){
	// clear the visible timer.
	document.getElementById("counter").innerHTML = "00:00:00";
	pauseTimer();
}
function doNothing(){
    return;
}
function stopSound(){
	// remove the bgsound tag settings.
	document.getElementById("clock").loop = alarmRepeat;
	document.getElementById("clock").volume = volSetting;
    document.getElementById("clock").src = "";
}
function setButton(id,src,script){
	// give an image some src and onclick values
    var item = document.getElementById(id);
    item.src = src;
    item.onclick = script;
}
function settingsClosed(event){
	// get the new Settings and set the visible timer accordingly.
	if(event.closeAction == event.Action.commit){
		hrs = System.Gadget.Settings.readString("hours");
		mins = System.Gadget.Settings.readString("minutes");
		secs = System.Gadget.Settings.readString("seconds");
		alarmFile = "file:///"+System.Gadget.Settings.readString("soundURL");
		alarmRepeat = System.Gadget.Settings.readString("soundRepeat");
		if(System.Gadget.Settings.readString("volume") == "on")volSetting = 0;else volSetting = -10000;
		milliSecs = (hrs*60*60+mins*60+secs)*1000;
		document.getElementById("counter").innerHTML = showTime(milliSecs);
		init();
	}
	event.cancel = false;
}
function showHelp(){
	System.Gadget.Flyout.show = true;
}
window.onload = function(){
	init();
}